# flake-o-rama

nix flake config! this is just used on my personal server at the moment

please do not use this as a learning resource for nix as i have essentially zero clue what i'm doing

## users

this flake is built for a multi-user experience per host, enforced by [`modules/users.nix`](./modules/users.nix), and found in the `default.nix` file for each host.

as this is a multi-user setup, the `dotfiles` group will be used for read and write access to the flake

## development

to build the system, run `sudo nixos-rebuild switch --flake .#server`

please periodically run `nix flake update` to make sure we arent slacking on package versions

before committing, please run `nix flake check` and make sure everything is ok

## todo

- remove the lua static stuff from nginx + maybe cloudflare ips too
- per-host architecture selection, atm it is hardcoded to `aarch64`
- some weird perl error abt locales when building using doas - `keepEnv` might fix this
- fix the logrotate error, only patchable with the hack displayed in [`hosts/server/default.nix`](./hosts/server/default.nix)
- leverage nixos-hardware
- somehow add desktop evironments and per-user dotfiles while keeping a multi-user setup
